const { fs } = require('./../bootstrap/modules');
const babel = require("@babel/core");

async function startProducing(command) {
    if (!fs.exists(MAIN_CONFIG_PATH)) {
        die(cli.white(`Framework is not configured, please run ${cli.green(process.env.CLI_NAME + ' fresh-install')} first.`));
    }

    // let result = babel.transformSync(fs.get(ROOT + '/p.js'), {
    //     envName: 'production',
    //     "comments": false,
    //     presets: [
    //         '@babel/preset-env',
    //         ["minify", {
    //             "mangle": {
    //                 "keepFnName": true
    //             }
    //         }]
    //     ]
    // });
    // fs.put(ROOT + '/p2.js', result.code);
    // die();

    let config = fs.getJson(MAIN_CONFIG_PATH);
    // remove the old dist
    fs.remove(ROOT + '/dist');
    // create again
    fs.makeDirectory(ROOT + '/dist');

    for (let appName in config.apps) {
        require(FRAMEWORK_ROOT_PATH + '/bootstrap/app-config')(appName);
        let { sassCompiler } = require(FRAMEWORK_ROOT_PATH + '/bootstrap');

        global.echo.sameLine = console.log;

        sassCompiler.setOptions({
            root: ROOT,
            srcDir: SRC_DIR,
            appDir: APP_DIR,
            appName: APP_NAME,
        });

        const buildApp = require('./../app-compiler');
        
        await buildApp();
        await sassCompiler.clear('ltr').compile('ltr');
        await sassCompiler.clear('rtl').compile('rtl');

        require('./../production/compiler')(appName, command);
    }

    die();
}

module.exports = function (command) {
    startProducing(command);
}