const { fs } = require('./../bootstrap/modules');

function copyAssets(STATIC_DIR) {
    for (let assets of resources.assets) {
        let dist = assets.dist;

        for (let asset of assets.src) {
            if (!fs.isDir(asset)) {
                throw new Error(`${asset} asset doesn't exists`);
            }

            fs.copy(asset, STATIC_DIR + '/' + dist);
        }
    }
}

module.exports = appName => {
    const hashCode = random(24);
    const appDistPath = ROOT + '/dist/' + appName;
    
    // remove the old dist
    fs.remove(appDistPath);
    // create it again
    fs.makeDirectory(appDistPath);
    // create js directory
    fs.makeDirectory(appDistPath + '/js');
    // create css directory
    fs.makeDirectory(appDistPath + '/css');
    // copy css files
    fs.copy(STATIC_DIR + '/css', appDistPath + '/css');
    // copy assets
    copyAssets(appDistPath);
    // compile vendors
    require('./compile-vendors')(hashCode, appDistPath);
    // compile application
    require('./compile-application')(hashCode, appDistPath, appName);
};