const globalize = require('./../bootstrap/globals');
const clients = require('./../sockets/clients');
const buildApp = require('./../app-compiler');
const server = require('./server');
require('./globals');

const io = require('socket.io')(process.env.SOCKET_PORT);
globalize('io', io);

class Server {
    constructor(command) {
        this.command = command;
        this.serverIsReadyToLunch = false;
        this.handleSockets();
        this.init();
        this.serve();
    }

    handleSockets() {
        io.on('connection', client => {
            clients.add(client);
            client.on('disconnect', () => {
                clients.remove(client);
            });
        });
    }

    init() {
        echo.sameLine(cli.blueBright('Starting server...'));

        globalize('serverIsReady', (isReady = null) => {
            if (typeof isReady !== null) return this.serverIsReadyToLunch;
            return this.serverIsReadyToLunch = isReady;
        });
    }

    serve() {
        buildApp().then(() => {
            // require('./di-compiler');
            this.startApp();
            io.emit('reconnected');
        });
    }

    startApp() {
        this.serverIsReadyToLunch = true;
        server.start(this.command);
    }
}

module.exports = command => new Server(command);